import { BlockContent, Blockquote } from 'mdast';
import { Node } from 'unist';
/**
 * @param children - The children of the blockquote.
 * @returns The blockquote.
 */
export declare function createBlockquote(children?: BlockContent[]): Blockquote;
/**
 * Type guard for Blockquote.
 *
 * @param node - The node to test.
 * @returns True if node is Blockquote.
 */
export declare function isBlockquote(node: Node): node is Blockquote;
/**
 * Type assertion for Blockquote.
 *
 * @param node - The node to test.
 */
export declare function assertBlockquote(node: Node): asserts node is Blockquote;
