"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The children of the blockquote.
 * @returns The blockquote.
 */
function createBlockquote(children = []) {
    return { type: 'blockquote', children };
}
exports.createBlockquote = createBlockquote;
/**
 * Type guard for Blockquote.
 *
 * @param node - The node to test.
 * @returns True if node is Blockquote.
 */
function isBlockquote(node) {
    return node.type === 'blockquote';
}
exports.isBlockquote = isBlockquote;
/**
 * Type assertion for Blockquote.
 *
 * @param node - The node to test.
 */
function assertBlockquote(node) {
    if (!isBlockquote(node)) {
        throw new Error('Node is not a Blockquote');
    }
}
exports.assertBlockquote = assertBlockquote;
//# sourceMappingURL=Blockquote.js.map