"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @returns The break.
 */
function createBreak() {
    return { type: 'break' };
}
exports.createBreak = createBreak;
/**
 * Type guard for Break.
 *
 * @param node - The node to test.
 * @returns True if node is Break.
 */
function isBreak(node) {
    return node.type === 'break';
}
exports.isBreak = isBreak;
/**
 * Type assertion for Break.
 *
 * @param node - The node to test.
 */
function assertBreak(node) {
    if (!isBreak(node)) {
        throw new Error('Node is not a Break');
    }
}
exports.assertBreak = assertBreak;
//# sourceMappingURL=Break.js.map