import { Code } from 'mdast';
import { Node } from 'unist';
interface Options {
    lang?: string;
    meta?: string;
}
/**
 * @param value - The content of the code.
 * @param lang - The language of computer code being marked up.
 * @param meta - If lang, custom information relating to the node.
 * @returns The code.
 */
export declare function createCode(value: string, lang?: string, meta?: string): Code;
/**
 * @param value - The content of the code.
 * @param options - The options of the code.
 * @returns The code.
 */
export declare function createCode(value: string, options: Options): Code;
/**
 * Type guard for Code.
 *
 * @param node - The node to test.
 * @returns True if node is Code.
 */
export declare function isCode(node: Node): node is Code;
/**
 * Type assertion for Code.
 *
 * @param node - The node to test.
 */
export declare function assertCode(node: Node): asserts node is Code;
export {};
