"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Implementation.
 */
function createCode(value, langOrOptions, meta) {
    let options;
    if (langOrOptions === undefined) {
        options = {};
    }
    else if (typeof langOrOptions === 'string') {
        options = { lang: langOrOptions };
    }
    else {
        options = { ...langOrOptions };
    }
    if (meta !== undefined) {
        options.meta = meta;
    }
    return { type: 'code', value, ...options };
}
exports.createCode = createCode;
/**
 * Type guard for Code.
 *
 * @param node - The node to test.
 * @returns True if node is Code.
 */
function isCode(node) {
    return node.type === 'code';
}
exports.isCode = isCode;
/**
 * Type assertion for Code.
 *
 * @param node - The node to test.
 */
function assertCode(node) {
    if (!isCode(node)) {
        throw new Error('Node is not a Code');
    }
}
exports.assertCode = assertCode;
//# sourceMappingURL=Code.js.map