"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ListContent_1 = require("../ListContent");
const PhrasingContent_1 = require("../PhrasingContent");
const RowContent_1 = require("../RowContent");
const TableContent_1 = require("../TableContent");
const TopLevelContent_1 = require("../TopLevelContent");
/**
 * Type guard for Content.
 *
 * @param node - The node to test.
 * @returns True if node is Content.
 */
function isContent(node) {
    return (TopLevelContent_1.isTopLevelContent(node) ||
        ListContent_1.isListContent(node) ||
        TableContent_1.isTableContent(node) ||
        RowContent_1.isRowContent(node) ||
        PhrasingContent_1.isPhrasingContent(node));
}
exports.isContent = isContent;
/**
 * Type assertion for Content.
 *
 * @param node - The node to test.
 */
function assertContent(node) {
    if (!isContent(node)) {
        throw new Error('Node is not a Content');
    }
}
exports.assertContent = assertContent;
//# sourceMappingURL=Content.js.map