"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Definition_1 = require("../Definition");
const FootnoteDefinition_1 = require("../FootnoteDefinition");
/**
 * Type guard for DefinitionContent.
 *
 * @param node - The node to test.
 * @returns True if node is DefinitionContent.
 */
function isDefinitionContent(node) {
    return Definition_1.isDefinition(node) || FootnoteDefinition_1.isFootnoteDefinition(node);
}
exports.isDefinitionContent = isDefinitionContent;
/**
 * Type assertion for DefinitionContent.
 *
 * @param node - The node to test.
 */
function assertDefinitionContent(node) {
    if (!isDefinitionContent(node)) {
        throw new Error('Node is not a DefinitionContent');
    }
}
exports.assertDefinitionContent = assertDefinitionContent;
//# sourceMappingURL=DefinitionContent.js.map