"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The deleted content.
 * @returns The delete.
 */
function createDelete(children = []) {
    return { type: 'delete', children };
}
exports.createDelete = createDelete;
/**
 * Type guard for Delete.
 *
 * @param node - The node to test.
 * @returns True if node is Delete.
 */
function isDelete(node) {
    return node.type === 'delete';
}
exports.isDelete = isDelete;
/**
 * Type assertion for Delete.
 *
 * @param node - The node to test.
 */
function assertDelete(node) {
    if (!isDelete(node)) {
        throw new Error('Node is not a Delete');
    }
}
exports.assertDelete = assertDelete;
//# sourceMappingURL=Delete.js.map