"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The emphasis content.
 * @returns The emphasis.
 */
function createEmphasis(children = []) {
    return { type: 'emphasis', children };
}
exports.createEmphasis = createEmphasis;
/**
 * Type guard for Emphasis.
 *
 * @param node - The node to test.
 * @returns True if node is Emphasis.
 */
function isEmphasis(node) {
    return node.type === 'emphasis';
}
exports.isEmphasis = isEmphasis;
/**
 * Type assertion for Emphasis.
 *
 * @param node - The node to test.
 */
function assertEmphasis(node) {
    if (!isEmphasis(node)) {
        throw new Error('Node is not an Emphasis');
    }
}
exports.assertEmphasis = assertEmphasis;
//# sourceMappingURL=Emphasis.js.map