"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Implementation.
 */
function createFootnote(children = []) {
    return { type: 'footnote', children };
}
exports.createFootnote = createFootnote;
/**
 * Type guard for Footnote.
 *
 * @param node - The node to test.
 * @returns True if node is Footnote.
 */
function isFootnote(node) {
    return node.type === 'footnote';
}
exports.isFootnote = isFootnote;
/**
 * Type assertion for Footnote.
 *
 * @param node - The node to test.
 */
function assertFootnote(node) {
    if (!isFootnote(node)) {
        throw new Error('Node is not a Footnote');
    }
}
exports.assertFootnote = assertFootnote;
//# sourceMappingURL=Footnote.js.map