"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-enable @typescript-eslint/unified-signatures */
/*
 * Implementation.
 */
function createFootnoteDefinition(identifier, labelOrChildrenOrOptions, children) {
    let options;
    if (labelOrChildrenOrOptions === undefined) {
        options = { children: [] };
    }
    else if (typeof labelOrChildrenOrOptions === 'string') {
        options = { label: labelOrChildrenOrOptions, children: [] };
    }
    else if (Array.isArray(labelOrChildrenOrOptions)) {
        options = { children: labelOrChildrenOrOptions };
    }
    else {
        options = { ...labelOrChildrenOrOptions, children: [] };
    }
    if (children) {
        options.children = children;
    }
    return { type: 'footnoteDefinition', identifier, ...options };
}
exports.createFootnoteDefinition = createFootnoteDefinition;
/**
 * Type guard for FootnoteDefinition.
 *
 * @param node - The node to test.
 * @returns True if node is FootnoteDefinition.
 */
function isFootnoteDefinition(node) {
    return node.type === 'footnoteDefinition';
}
exports.isFootnoteDefinition = isFootnoteDefinition;
/**
 * Type assertion for FootnoteDefinition.
 *
 * @param node - The node to test.
 */
function assertFootnoteDefinition(node) {
    if (!isFootnoteDefinition(node)) {
        throw new Error('Node is not a FootnoteDefinition');
    }
}
exports.assertFootnoteDefinition = assertFootnoteDefinition;
//# sourceMappingURL=FootnoteDefinition.js.map