import { FootnoteReference } from 'mdast';
import { Node } from 'unist';
interface Options {
    label?: string;
}
/**
 * @param identifier - The reference identifier.
 * @param label - An optional label.
 * @returns The footnote reference.
 */
export declare function createFootnoteReference(identifier: string, label?: string): FootnoteReference;
/**
 * @param identifier - The reference identifier.
 * @param options - The options of the footnote reference.
 * @returns The footnote reference.
 */
export declare function createFootnoteReference(identifier: string, options: Options): FootnoteReference;
/**
 * Type guard for FootnoteReference.
 *
 * @param node - The node to test.
 * @returns True if node is FootnoteReference.
 */
export declare function isFootnoteReference(node: Node): node is FootnoteReference;
/**
 * Type assertion for FootnoteReference.
 *
 * @param node - The node to test.
 */
export declare function assertFootnoteReference(node: Node): asserts node is FootnoteReference;
export {};
