"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Implementation.
 */
function createFootnoteReference(identifier, labelOrOptions) {
    let options;
    if (labelOrOptions === undefined) {
        options = {};
    }
    else if (typeof labelOrOptions === 'string') {
        options = { label: labelOrOptions };
    }
    else {
        options = { ...labelOrOptions };
    }
    return { type: 'footnoteReference', identifier, ...options };
}
exports.createFootnoteReference = createFootnoteReference;
/**
 * Type guard for FootnoteReference.
 *
 * @param node - The node to test.
 * @returns True if node is FootnoteReference.
 */
function isFootnoteReference(node) {
    return node.type === 'footnoteReference';
}
exports.isFootnoteReference = isFootnoteReference;
/**
 * Type assertion for FootnoteReference.
 *
 * @param node - The node to test.
 */
function assertFootnoteReference(node) {
    if (!isFootnoteReference(node)) {
        throw new Error('Node is not a FootnoteReference');
    }
}
exports.assertFootnoteReference = assertFootnoteReference;
//# sourceMappingURL=FootnoteReference.js.map