"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const YAML_1 = require("../YAML");
/**
 * Type guard for FrontmatterContent.
 *
 * @param node - The node to test.
 * @returns True if node is FrontmatterContent.
 */
function isFrontmatterContent(node) {
    return YAML_1.isYAML(node);
}
exports.isFrontmatterContent = isFrontmatterContent;
/**
 * Type assertion for FrontmatterContent.
 *
 * @param node - The node to test.
 */
function assertFrontmatterContent(node) {
    if (!isFrontmatterContent(node)) {
        throw new Error('Node is not a FrontmatterContent');
    }
}
exports.assertFrontmatterContent = assertFrontmatterContent;
//# sourceMappingURL=FrontmatterContent.js.map