"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param value - The HTML content.
 * @returns The HTML.
 */
function createHTML(value) {
    return { type: 'html', value };
}
exports.createHTML = createHTML;
/**
 * Type guard for HTML.
 *
 * @param node - The node to test.
 * @returns True if node is HTML.
 */
function isHTML(node) {
    return node.type === 'html';
}
exports.isHTML = isHTML;
/**
 * Type assertion for HTML.
 *
 * @param node - The node to test.
 */
function assertHTML(node) {
    if (!isHTML(node)) {
        throw new Error('Node is not a HTML');
    }
}
exports.assertHTML = assertHTML;
//# sourceMappingURL=HTML.js.map