import { Heading, PhrasingContent } from 'mdast';
import { Node } from 'unist';
/**
 * @param depth - The depth of the heading.
 * @param children - The children of the heading.
 * @returns The heading.
 */
export declare function createHeading(depth: 1 | 2 | 3 | 4 | 5 | 6, children?: PhrasingContent[]): Heading;
/**
 * Type guard for Heading.
 *
 * @param node - The node to test.
 * @returns True if node is Heading.
 */
export declare function isHeading(node: Node): node is Heading;
/**
 * Type assertion for Heading.
 *
 * @param node - The node to test.
 */
export declare function assertHeading(node: Node): asserts node is Heading;
