"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param depth - The depth of the heading.
 * @param children - The children of the heading.
 * @returns The heading.
 */
function createHeading(depth, children = []) {
    return { type: 'heading', depth, children };
}
exports.createHeading = createHeading;
/**
 * Type guard for Heading.
 *
 * @param node - The node to test.
 * @returns True if node is Heading.
 */
function isHeading(node) {
    return node.type === 'heading';
}
exports.isHeading = isHeading;
/**
 * Type assertion for Heading.
 *
 * @param node - The node to test.
 */
function assertHeading(node) {
    if (!isHeading(node)) {
        throw new Error('Node is not a Heading');
    }
}
exports.assertHeading = assertHeading;
//# sourceMappingURL=Heading.js.map