import { Image } from 'mdast';
import { Node } from 'unist';
interface Options {
    alt?: string;
    title?: string;
}
/**
 * @param url - URL to the referenced resource.
 * @param alt - The alternative text.
 * @param title - Advisory information for the resource.
 * @returns The image.
 */
export declare function createImage(url: string, alt?: string, title?: string): Image;
/**
 * @param url - URL to the referenced resource.
 * @param options - The options of the definition.
 * @returns The image.
 */
export declare function createImage(url: string, options: Options): Image;
/**
 * Type guard for Image.
 *
 * @param node - The node to test.
 * @returns True if node is Image.
 */
export declare function isImage(node: Node): node is Image;
/**
 * Type assertion for Image.
 *
 * @param node - The node to test.
 */
export declare function assertImage(node: Node): asserts node is Image;
export {};
