"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param value - The value of the inline code.
 * @returns The inline code.
 */
function createInlineCode(value) {
    return { type: 'inlineCode', value };
}
exports.createInlineCode = createInlineCode;
/**
 * Type guard for InlineCode.
 *
 * @param node - The node to test.
 * @returns True if node is InlineCode.
 */
function isInlineCode(node) {
    return node.type === 'inlineCode';
}
exports.isInlineCode = isInlineCode;
/**
 * Type assertion for InlineCode.
 *
 * @param node - The node to test.
 */
function assertInlineCode(node) {
    if (!isInlineCode(node)) {
        throw new Error('Node is not an InlineCode');
    }
}
exports.assertInlineCode = assertInlineCode;
//# sourceMappingURL=InlineCode.js.map