"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-enable @typescript-eslint/unified-signatures */
/*
 * Implementation.
 */
function createLinkReference(identifier, referenceType, labelOrChildrenOrOptions, children) {
    let options;
    if (labelOrChildrenOrOptions === undefined) {
        options = { children: [] };
    }
    else if (typeof labelOrChildrenOrOptions === 'string') {
        options = { label: labelOrChildrenOrOptions, children: [] };
    }
    else if (Array.isArray(labelOrChildrenOrOptions)) {
        options = { children: labelOrChildrenOrOptions };
    }
    else {
        options = { ...labelOrChildrenOrOptions, children: [] };
    }
    if (children) {
        options.children = children;
    }
    return { type: 'linkReference', identifier, referenceType, ...options };
}
exports.createLinkReference = createLinkReference;
/**
 * Type guard for LinkReference.
 *
 * @param node - The node to test.
 * @returns True if node is LinkReference.
 */
function isLinkReference(node) {
    return node.type === 'linkReference';
}
exports.isLinkReference = isLinkReference;
/**
 * Type assertion for LinkReference.
 *
 * @param node - The node to test.
 */
function assertLinkReference(node) {
    if (!isLinkReference(node)) {
        throw new Error('Node is not a LinkReference');
    }
}
exports.assertLinkReference = assertLinkReference;
//# sourceMappingURL=LinkReference.js.map