"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Type guard for Literal.
 *
 * @param node - The node to test.
 * @returns True if node is Literal.
 */
function isLiteral(node) {
    return 'value' in node && typeof node.value === 'string';
}
exports.isLiteral = isLiteral;
/**
 * Type assertion for Literal.
 *
 * @param node - The node to test.
 */
function assertLiteral(node) {
    if (!isLiteral(node)) {
        throw new Error('Node is not a Literal');
    }
}
exports.assertLiteral = assertLiteral;
//# sourceMappingURL=Literal.js.map