import { Paragraph, PhrasingContent } from 'mdast';
import { Node } from 'unist';
/**
 * @param children - The children of the paragraph.
 * @returns The paragraph.
 */
export declare function createParagraph(children?: PhrasingContent[]): Paragraph;
/**
 * Type guard for Paragraph.
 *
 * @param node - The node to test.
 * @returns True if node is Paragraph.
 */
export declare function isParagraph(node: Node): node is Paragraph;
/**
 * Type assertion for Paragraph.
 *
 * @param node - The node to test.
 */
export declare function assertParagraph(node: Node): asserts node is Paragraph;
