"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The children of the paragraph.
 * @returns The paragraph.
 */
function createParagraph(children = []) {
    return { type: 'paragraph', children };
}
exports.createParagraph = createParagraph;
/**
 * Type guard for Paragraph.
 *
 * @param node - The node to test.
 * @returns True if node is Paragraph.
 */
function isParagraph(node) {
    return node.type === 'paragraph';
}
exports.isParagraph = isParagraph;
/**
 * Type assertion for Paragraph.
 *
 * @param node - The node to test.
 */
function assertParagraph(node) {
    if (!isParagraph(node)) {
        throw new Error('Node is not a Paragraph');
    }
}
exports.assertParagraph = assertParagraph;
//# sourceMappingURL=Paragraph.js.map