"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Content_1 = require("../Content");
/**
 * Type guard for Parent.
 *
 * @param node - The node to test.
 * @returns True if node is Parent.
 */
function isParent(node) {
    return ('children' in node && Array.isArray(node.children) && node.children.every((n) => Content_1.isContent(n)));
}
exports.isParent = isParent;
/**
 * Type assertion for Parent.
 *
 * @param node - The node to test.
 */
function assertParent(node) {
    if (!isParent(node)) {
        throw new Error('Node is not a Parent');
    }
}
exports.assertParent = assertParent;
//# sourceMappingURL=Parent.js.map