"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Link_1 = require("../Link");
const LinkReference_1 = require("../LinkReference");
const StaticPhrasingContent_1 = require("../StaticPhrasingContent");
/**
 * Type guard for PhrasingContent.
 *
 * @param node - The node to test.
 * @returns True if node is PhrasingContent.
 */
function isPhrasingContent(node) {
    return StaticPhrasingContent_1.isStaticPhrasingContent(node) || Link_1.isLink(node) || LinkReference_1.isLinkReference(node);
}
exports.isPhrasingContent = isPhrasingContent;
/**
 * Type assertion for PhrasingContent.
 *
 * @param node - The node to test.
 */
function assertPhrasingContent(node) {
    if (!isPhrasingContent(node)) {
        throw new Error('Node is not a PhrasingContent');
    }
}
exports.assertPhrasingContent = assertPhrasingContent;
//# sourceMappingURL=PhrasingContent.js.map