"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The children of the root.
 * @returns The root.
 */
function createRoot(children = []) {
    return { type: 'root', children };
}
exports.createRoot = createRoot;
/**
 * Type guard for Root.
 *
 * @param node - The node to test.
 * @returns True if node is Root.
 */
function isRoot(node) {
    return node.type === 'root';
}
exports.isRoot = isRoot;
/**
 * Type assertion for Root.
 *
 * @param node - The node to test.
 */
function assertRoot(node) {
    if (!isRoot(node)) {
        throw new Error('Node is not a Root');
    }
}
exports.assertRoot = assertRoot;
//# sourceMappingURL=Root.js.map