"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The strong content.
 * @returns The strong.
 */
function createStrong(children = []) {
    return { type: 'strong', children };
}
exports.createStrong = createStrong;
/**
 * Type guard for Strong.
 *
 * @param node - The node to test.
 * @returns True if node is Strong.
 */
function isStrong(node) {
    return node.type === 'strong';
}
exports.isStrong = isStrong;
/**
 * Type assertion for Strong.
 *
 * @param node - The node to test.
 */
function assertStrong(node) {
    if (!isStrong(node)) {
        throw new Error('Node is not a Strong');
    }
}
exports.assertStrong = assertStrong;
//# sourceMappingURL=Strong.js.map