import { TableCell, PhrasingContent } from 'mdast';
import { Node } from 'unist';
/**
 * @param children - The children of the table cell.
 * @returns The table cell.
 */
export declare function createTableCell(children?: PhrasingContent[]): TableCell;
/**
 * Type guard for TableCell.
 *
 * @param node - The node to test.
 * @returns True if node is TableCell.
 */
export declare function isTableCell(node: Node): node is TableCell;
/**
 * Type assertion for TableCell.
 *
 * @param node - The node to test.
 */
export declare function assertTableCell(node: Node): asserts node is TableCell;
