"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The children of the table cell.
 * @returns The table cell.
 */
function createTableCell(children = []) {
    return { type: 'tableCell', children };
}
exports.createTableCell = createTableCell;
/**
 * Type guard for TableCell.
 *
 * @param node - The node to test.
 * @returns True if node is TableCell.
 */
function isTableCell(node) {
    return node.type === 'tableCell';
}
exports.isTableCell = isTableCell;
/**
 * Type assertion for TableCell.
 *
 * @param node - The node to test.
 */
function assertTableCell(node) {
    if (!isTableCell(node)) {
        throw new Error('Node is not a TableCell');
    }
}
exports.assertTableCell = assertTableCell;
//# sourceMappingURL=TableCell.js.map