"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TableRow_1 = require("../TableRow");
/**
 * Type guard for TableContent.
 *
 * @param node - The node to test.
 * @returns True if node is TableContent.
 */
function isTableContent(node) {
    return TableRow_1.isTableRow(node);
}
exports.isTableContent = isTableContent;
/**
 * Type assertion for TableContent.
 *
 * @param node - The node to test.
 */
function assertTableContent(node) {
    if (!isTableContent(node)) {
        throw new Error('Node is not a TableContent');
    }
}
exports.assertTableContent = assertTableContent;
//# sourceMappingURL=TableContent.js.map