import { RowContent, TableRow } from 'mdast';
import { Node } from 'unist';
/**
 * @param children - The children of the table row.
 * @returns The table row.
 */
export declare function createTableRow(children?: RowContent[]): TableRow;
/**
 * Type guard for TableRow.
 *
 * @param node - The node to test.
 * @returns True if node is TableRow.
 */
export declare function isTableRow(node: Node): node is TableRow;
/**
 * Type assertion for TableRow.
 *
 * @param node - The node to test.
 */
export declare function assertTableRow(node: Node): asserts node is TableRow;
