"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param children - The children of the table row.
 * @returns The table row.
 */
function createTableRow(children = []) {
    return { type: 'tableRow', children };
}
exports.createTableRow = createTableRow;
/**
 * Type guard for TableRow.
 *
 * @param node - The node to test.
 * @returns True if node is TableRow.
 */
function isTableRow(node) {
    return node.type === 'tableRow';
}
exports.isTableRow = isTableRow;
/**
 * Type assertion for TableRow.
 *
 * @param node - The node to test.
 */
function assertTableRow(node) {
    if (!isTableRow(node)) {
        throw new Error('Node is not a TableRow');
    }
}
exports.assertTableRow = assertTableRow;
//# sourceMappingURL=TableRow.js.map