"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param value - The value of the text.
 * @returns The text.
 */
function createText(value) {
    return { type: 'text', value };
}
exports.createText = createText;
/**
 * Type guard for Text.
 *
 * @param node - The node to test.
 * @returns True if node is Text.
 */
function isText(node) {
    return node.type === 'text';
}
exports.isText = isText;
/**
 * Type assertion for Text.
 *
 * @param node - The node to test.
 */
function assertText(node) {
    if (!isText(node)) {
        throw new Error('Node is not a Text');
    }
}
exports.assertText = assertText;
//# sourceMappingURL=Text.js.map