"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @returns The thematic break.
 */
function createThematicBreak() {
    return { type: 'thematicBreak' };
}
exports.createThematicBreak = createThematicBreak;
/**
 * Type guard for ThematicBreak.
 *
 * @param node - The node to test.
 * @returns True if node is ThematicBreak.
 */
function isThematicBreak(node) {
    return node.type === 'thematicBreak';
}
exports.isThematicBreak = isThematicBreak;
/**
 * Type assertion for ThematicBreak.
 *
 * @param node - The node to test.
 */
function assertThematicBreak(node) {
    if (!isThematicBreak(node)) {
        throw new Error('Node is not a ThematicBreak');
    }
}
exports.assertThematicBreak = assertThematicBreak;
//# sourceMappingURL=ThematicBreak.js.map