"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BlockContent_1 = require("../BlockContent");
const DefinitionContent_1 = require("../DefinitionContent");
const FrontmatterContent_1 = require("../FrontmatterContent");
/**
 * Type guard for TopLevelContent.
 *
 * @param node - The node to test.
 * @returns True if node is TopLevelContent.
 */
function isTopLevelContent(node) {
    return BlockContent_1.isBlockContent(node) || FrontmatterContent_1.isFrontmatterContent(node) || DefinitionContent_1.isDefinitionContent(node);
}
exports.isTopLevelContent = isTopLevelContent;
/**
 * Type assertion for TopLevelContent.
 *
 * @param node - The node to test.
 */
function assertTopLevelContent(node) {
    if (!isTopLevelContent(node)) {
        throw new Error('Node is not a TopLevelContent');
    }
}
exports.assertTopLevelContent = assertTopLevelContent;
//# sourceMappingURL=TopLevelContent.js.map