"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param value - The content of the YAML.
 * @returns The YAML.
 */
function createYAML(value) {
    return { type: 'yaml', value };
}
exports.createYAML = createYAML;
/**
 * Type guard for YAML.
 *
 * @param node - The node to test.
 * @returns True if node is YAML.
 */
function isYAML(node) {
    return node.type === 'yaml';
}
exports.isYAML = isYAML;
/**
 * Type assertion for YAML.
 *
 * @param node - The node to test.
 */
function assertYAML(node) {
    if (!isYAML(node)) {
        throw new Error('Node is not a YAML');
    }
}
exports.assertYAML = assertYAML;
//# sourceMappingURL=YAML.js.map